DAT programName byte "XmasArrayDemo121224g", 0 ' This will let me know what program is loaded in the Prop.
CON
{{
  ******* Public Notes *******

  Written By: Duane Degn
  Initial Release: November 2012
  MIT License (Use anyway you want but give me credit.)
  
   
}}
{
  ******* Private Notes *******
  Led8by8Demo121110a start work
  on 8x8 RGB LED array.
  Use H-bridge chips on anodes and high power shift registers on cathodes.
  10d Start adding RGB support to font generation.
  10g works at displaying a pattern.
  10g Doesn't turn on the bottom row as long as the other rows which causes
  the bottom row to be dim compared with other rows.
  11b Fixed dim row.
  11e I think the PWM rate is much too slow.
  11f Try to make PASM version of PWM code.
  11g Kind of works with 11c but it has a very noticable flicker.
  11h Getting better. Reduced resolution to 16 which got rid of the
  flicker. Solid colors are not solid. Orange causes red and yellow
  stripes.
  11l Works much better but only 64-bit color.
  11m Try to increase resolution. Using 125 bit resolution still looks good.
  Works with 11j.
  11m Tried with 5, 6 and 7 bits each color. 7 bits had too much flicker.
  Propbably stay with 5 bits per color.
  11n Add menu back.
  12b Text kind of scrolls but only in red and it looks like each pixel
  is three LEDs wide.
  12e still has problems with scrolling text.
  12f Text scrolling works.
  XmasArrayDemo121223d Convert program to use G-35 Xmas LEDs.
  23c Works enough to rotate stripes across array.
  23d Try to get font building to work.
  23d Program stops after building font.
  24b Vertical lines of turned off bulbs scroll instead of scrolling
  text. I suspect a problem with the "buildFont" method.
  24c Seems to be working.
  24d Also works.
  24f Larsen scanner is not working correctly. Starts and ends at the wrong places.
  
} 
CON


  _CLKMODE = XTAL1 + PLL16X                             ' use crystal x 16
  _XINFREQ = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  ' Set this to the pins you have connected to the 74HC595's


  SHIFT_DATA = 16
  SHIFT_CLOCK = 27 
  SHIFT_LATCH = 15         

  FIRST_ANODE_PIN = 0
  
  DEFAULT_LED_FREQUENCY = 1000
  DEFAULT_LED_RESOLUTION = 16 '256
  STEPS_TO_PULSE = DEFAULT_LED_RESOLUTION
  DATA_RESOLUTION = 256
  STACK_SIZE = 200 '100
  BAUD = 115_200

  NUMBER_OF_RGB_LEDS = Led#ROWS * Led#DISPLAY_COLUMNS 'DISPLAY_PIXELS
  NUMBER_OF_LEDS = NUMBER_OF_RGB_LEDS * 3

  DEFAULT_SHORT_PAUSE = 100
  BUFFER_DUMP_COLUMNS = 32
  TITLE_X = 3                   ' Location for title
  TITLE_Y = 3
 
  MODE_DISPLAY_X = TITLE_X + 11               
  MODE_DISPLAY_Y = TITLE_Y + 7
  ACTIVE_COLOR_DISPLAY_X = TITLE_X + 15               
  ACTIVE_COLOR_DISPLAY_Y = MODE_DISPLAY_Y + 1
  ACTIVE_LEDS_DISPLAY_X = TITLE_X + 14               
  ACTIVE_LEDS_DISPLAY_Y = ACTIVE_COLOR_DISPLAY_Y + 1
  ACTIVE_BRIGHTNESS_DISPLAY_X = TITLE_X + 20              
  ACTIVE_BRIGHTNESS_DISPLAY_Y = ACTIVE_LEDS_DISPLAY_Y + 1
 
  MENU_DISPLAY_X = TITLE_X                
  MENU_DISPLAY_Y = ACTIVE_BRIGHTNESS_DISPLAY_Y + 2
  'METHOD_MESSAGE_DISPLAY_X = MENU_DISPLAY_X
  'METHOD_MESSAGE_DISPLAY_Y = MENU_DISPLAY_Y + 18
  BUFFER_DUMP_Y = MENU_DISPLAY_Y + 18

  #0, FORWARD, BACKWARD

  COUNTER_CLOCKWISE = FORWARD
  CLOCKWISE = BACKWARD
  
  ' color enumeration tri color LEDs
  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, INDIGO

  #0, RED_PORTION, GREEN_PORTION, BLUE_PORTION, INTENSITY_PORTION

  ' LED modes  
 { #0, NAVIGATION_LEDS, CYCLON_LEDS, BOUNCING_COLORS_LEDS, WILD_LEDS, UNIFORM_RAINBOW_LEDS, {
    } VERIGATED_RAINBOW_LEDS, FLAME_LEDS, TEST_LEDS, CHASE_RED_LEDS, CHASE_GREEN_LEDS, {
    } CHASE_BLUE_LEDS, FLASH_WHITE_LEDS, BLUE_LEDS, GREEN_LEDS, RED_LEDS, WHITE_LEDS, {
    } PURPLE_LEDS, ORANGE_LEDS, YELLOW_LEDS, DYNAMIC_ALTITUDE_HOLD_LEDS, {
    } DISPLAY_ALTITUDE_LEDS, STATIC_ALTITUDE_HOLD_LEDS   }

  #0, OFF_MODE, LARSON_MODE, SOLID_MODE, DRAGON_MODE, TAIL_MODE, ROTATE_MODE, {
    } PULSE_MODE, BOW_MODE, PATTERN_MODE, CYCLE_MODE, TEXT_MODE, UPDATE_TEXT_MODE, {
    } RAINBOW_TEXT_MODE, WHITE_MODE, RAINBOW_ANGLED_MODE

  ' menuMode enumeration
  #0, CHOOSE_MODE, CHOOSE_COLOR, CHOOSE_NUMBER, CHOOSE_TEXT_MENU, CHOOSE_TEXT_MESSAGE, {
    } CHOOSE_CONFIRM_MESSAGE, CHOOSE_TEXT_COLOR

  ' ledType enumeration (only RGB LEDs are currently supported in this program)
  #1, SINGLE_COLOR, BI_COLOR, TRI_COLOR, LONG_COLOR
    ' I plan to add support for monochromatic LEDs but I don't presently
    ' have plans to support BI_COLOR LEDs.

  ' activeFont enumeration
  #0, FREE_DESIGN_FONT

  
CON

  EEPROM_FONT_ADDRESS = $8000
  FONT_HEIGHT = 8
  FONT_WIDTH = 8
  ARRAY_WIDTH = 13 '12 '8
  ARRAY_HEIGHT = 8
  ARRAYS_WIDE = 1
  ARRAYS_HIGH = 1
  DISPLAY_WIDTH_PIXELS = ARRAYS_WIDE * ARRAY_WIDTH ' 16
  'DISPLAY_BYTES_WIDTH = DISPLAY_WIDTH_PIXELS * LONG_COLOR 'TRI_COLOR
  DISPLAY_LONGS_WIDTH = DISPLAY_WIDTH_PIXELS
  DISPLAY_HEIGHT = ARRAYS_HIGH * ARRAY_HEIGHT
  'DISPLAY_BYTES = DISPLAY_BYTES_WIDTH * DISPLAY_HEIGHT
  DISPLAY_PIXELS = DISPLAY_WIDTH_PIXELS * DISPLAY_HEIGHT
  'FONT_EEPROM_BYTE_HEIGHT = FONT_HEIGHT
  FONT_EEPROM_LONGS_HEIGHT = FONT_HEIGHT
  'FONT_EEPROM_BYTE_WIDTH = FONT_WIDTH * LONG_COLOR 'TRI_COLOR
  FONT_EEPROM_LONGS_WIDTH = FONT_WIDTH 
  DEFAULT_INIT_SKIP = 2
  DEFAULT_END_SKIP = 3
  DEFAULT_SPACE_BETWEEN_LETTERS = 3
  DEFAULT_N_SPACING = 6 ' space between words
  DEFAULT_BRIGHTNESS = 100
  MAX_BRIGHTNESS = Led#DEFAULT_INTENSITY '$FF
  MIN_BRIGHTNESS = 0
  'FONT_BYTES_PER_CHARACTER = FONT_EEPROM_BYTE_HEIGHT * FONT_EEPROM_BYTE_WIDTH
  FONT_LONGS_PER_CHARACTER = FONT_EEPROM_LONGS_HEIGHT * FONT_EEPROM_LONGS_WIDTH
  'FONT_BYTES_IN_EEPROM = FONT_BYTES_PER_CHARACTER + 1 ' one byte to hold width of character
  FONT_LONGS_IN_EEPROM = FONT_LONGS_PER_CHARACTER + 1
  _DefaultDelay = 5_000_000
  _DelayInterval = 1_000_000
  _MinimunDelay = _DelayInterval
  
  LOWEST_ASCII_USED = 32
  HIGHEST_ASCII_USED = 126   
  '_LineLength = 12
  DEFAULT_H_SCROLL_DELAY = 50 '100
  LOAD_FONT_TIME = DEFAULT_H_SCROLL_DELAY - 1
  LARGEST_TEXT_MESSAGE = 140 'Pst#MAXSTR_LENGTH + 1 '160
  MAX_NUMBER_OF_MESSAGES = 256
  RAINBOW_TEXT_TRANSITIONS = 8
  
CON

  COLOR_BLACK = Led#COLOR_BLACK
  COLOR_WHITE = Led#COLOR_WHITE
  COLOR_BLUE = Led#COLOR_BLUE
  COLOR_GREEN = Led#COLOR_GREEN
  COLOR_RED = Led#COLOR_RED
  COLOR_CYAN = Led#COLOR_CYAN
  COLOR_MAGENTA = Led#COLOR_MAGENTA
  COLOR_YELLOW = Led#COLOR_YELLOW
  COLOR_ORANGE = Led#COLOR_ORANGE
  COLOR_VIOLET = Led#COLOR_VIOLET
  COLOR_INDIGO = Led#COLOR_INDIGO
  COLOR_OTHER_WHITE = Led#COLOR_OTHER_WHITE     
  COLOR_YELLOW_GREEN  = Led#COLOR_YELLOW_GREEN
  COLOR_RED_VIOLET = Led#COLOR_RED_VIOLET
  COLOR_RED_ORANGE = Led#COLOR_RED_ORANGE
  COLOR_DIM_GREEN = Led#COLOR_DIM_GREEN
  DEFAULT_INTENSITY = $CC
  INTENSITY = DEFAULT_INTENSITY << 12

  DEFAULT_TEXT = RED 'GREEN
  DEFAULT_BACKGROUND = COLOR_DIM_GREEN 'COLOR_RED
  RAINBOW_TEXT_BACKGROUND = WHITE

  FINAL_RAINBOW_COLOR = VIOLET
  INITIAL_RAINBOW_COLOR = RED
   
VAR

  'long frequency, duration
  long ledStack[STACK_SIZE]', cycleStack[STACK_SIZE]
  'long displayPort, displayStar
  'long directionCount
  'long bufferInUsePtr, previousBufferInUsePtr
  

  long globalWait
  long globalLastTime, oneSecond, millisecond
  long debugLock', globalIndex
  long timesToFlash, flashDurationMs
  'long coloredNumber, ledNumberFlashDelay
  'long lastDisplayTime, displayDelay
  long ledCog, brightness
  long activeLeds, activeLedsUpperLimit, activeLedsLowerLimit
  long shortPause, patternSize, horizontalScrollDelay, shortenedScrollDelay
  long globalBrightness, eepromFontColor
  long nextFreeEepromLoc, colorTransition[4]
  long globalColor[4]
  long displayBuffer[Led#BUFFER_SIZE]
  long tempBuffer[Led#BUFFER_SIZE]
  
  byte dayOfWeek, interuptFlag, globalChangeFlag
  byte {ledPwm[15], mainColor[3],} ledMode, previousLedMode
  'byte lastLedModeDisplayed
  'byte colorR[64], colorG[64], colorB[64], colorIndex

  'byte cycleFlag, cycleInterval
  'byte ledBuffer[NUMBER_OF_LEDS]
  byte altLedBuffer0[NUMBER_OF_LEDS], altLedBuffer1[NUMBER_OF_LEDS]
  long menuMode, ledType, activeColor', newLedModeFlag
  byte modifiableColorFlag, modifiableNumberFlag, modifiableBrightnessFlag
  
  byte activeTextColor, colorCount
  
OBJ

  Pst : "Parallax Serial Terminal"                      ' uses a cog
  Led : "xmas121224c"                       ' uses a cog
  Eeprom: "Propeller EepromDWD"
  
PUB stand_alone_test | localIndex, localIndex2
{{ Stand alone test. Used only when you run this object directly. }}
  ' Start up our cog.
  waitcnt(clkfreq * 4 + cnt)
   
  Led.StartTwo(12, 13, @displayBuffer)
  waitcnt(clkfreq / 4 + cnt)
   
  ' Give the attached string the default bulb enumeration.
  'Led.set_standard_enum
  'waitcnt(clkfreq / 4 + cnt)
  Led.LoadBufferOfPtrs
  { 
  repeat 1
    Led.VerticalStripes
    waitcnt(clkfreq / 2 + cnt)
    repeat 13
      Led.Rotate2DHorizontal(1)
      waitcnt(clkfreq / 10 + cnt)
    repeat 26
      Led.Rotate2DHorizontal(-1)
      waitcnt(clkfreq / 10 + cnt)
    Led.Rotate(1, 20, 100)
    Led.Rotate(-1, 20, 100)
    Led.Rotate(6, 20, 100)
    Led.Rotate(-6, 20, 100)
    Led.HorizontalStripes 
    waitcnt(clkfreq / 2 + cnt)
    repeat 8
      Led.Rotate2DVert(1)
      waitcnt(clkfreq / 10 + cnt)
    repeat 24
      Led.Rotate2DVert(-1)
      waitcnt(clkfreq / 10 + cnt)
    Led.Rotate(1, 20, 100)
    Led.Rotate(-1, 20, 100)  }
      
  SetUp 

PUB SetUp | localIndex, localCharacter, count, colorIndex1, colorIndex2, colorIndex3
' uses a cog 3 left
      'Initialize the RC input object
  
  Pst.Start(BAUD)
  oneSecond := clkfreq
  millisecond := clkfreq / 1000
  'displayDelay := oneSecond / 4
  'loopInterval := clkfreq / 50
  'loopInterval -= 2 * millisecond
 
  debugLock := locknew                                  ' used for debug output, not input
  timesToFlash := 8
  flashDurationMs := 250
  globalBrightness := DATA_RESOLUTION - 1
  ledType := LONG_COLOR 'TRI_COLOR
  brightness := DATA_RESOLUTION - 1
  modifiableColorFlag := 1
  modifiableNumberFlag := 1
  activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
  activeLedsLowerLimit := 0
  modifiableBrightnessFlag := 1
  ledMode := TEXT_MODE 'RAINBOW_TEXT_MODE 'OFF_MODE 'SOLID_MODE
  menuMode := CHOOSE_TEXT_MENU
  
  activeColor := DEFAULT_TEXT
  activeLeds := 5 'NUMBER_OF_RGB_LEDS
  shortPause := DEFAULT_SHORT_PAUSE
  horizontalScrollDelay := DEFAULT_H_SCROLL_DELAY
  shortenedScrollDelay := horizontalScrollDelay - LOAD_FONT_TIME
  waitcnt(clkfreq + cnt)
    
  'localCharacter := cognew(LightLeds, @ledStack)        ' uses a cog 1 left                                                  
  'waitcnt(clkfreq / 4 + cnt)
  if eepromFontColor <> activeColor
    nextFreeEepromLoc := BuildFont(activeColor)
    eepromFontColor := activeColor
    Eeprom.FromRam(@eepromFontColor, @eepromFontColor + 3, @eepromFontColor)
    Eeprom.FromRam(@nextFreeEepromLoc, @nextFreeEepromLoc + 3, @nextFreeEepromLoc)
    messageLocation[0] := @messageBuffer
    messageSize[0] := strsize(@messageBuffer)
    Eeprom.FromRam(@messageLocation, @messageLocation + 3, @messageLocation)
    Eeprom.FromRam(@messageSize, @messageSize, @messageSize)
    messagesSavedCount := 1
    Eeprom.FromRam(@messagesSavedCount, @messagesSavedCount + 3, @messagesSavedCount)
    
  bufferSavedFlag := 1    
  repeat until not lockset(debugLock)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.str(string("Xmas LED Array Demo"))
  Pst.Position(TITLE_X, TITLE_Y + 2)
  Pst.str(string("program name of top object = "))
  Pst.str(@programName)
  Pst.Position(TITLE_X, TITLE_Y + 3)
  'Pst.str(string("program name of LED object = "))
  'Pst.str(Led.GetProgramName)
  'Pst.Position(TITLE_X, TITLE_Y + 4)
  'Pst.str(string("ledCog = "))
  'Pst.dec(ledCog)
  'Pst.str(@activeText)
  lockclr(debugLock)
  localCharacter := cognew(LightLeds, @ledStack)        ' uses a cog 1 left                                                  
  
  waitcnt(clkfreq / 4 + cnt)
 
  MainLoop

PUB MainLoop | colorIndex, brightnessIndex, direction 
''  This method resides in cog 0.  It checks for new information
''  received by other cogs and takes action based on such information.

 
  timesToFlash := 2
  flashDurationMs := 250
  patternSize := @patternD01 - @patternD02
  direction := 1
  repeat
    case menuMode
      CHOOSE_MODE: ModeMenu
      CHOOSE_COLOR: ColorMenu
      CHOOSE_NUMBER: EnterNumber
      CHOOSE_TEXT_MENU: TextMenu
      CHOOSE_TEXT_MESSAGE: EnterText
      CHOOSE_CONFIRM_MESSAGE: ConfirmText
      ' ** add option to change timing


PUB ModeMenu | localCharacter, combinedFlags, previousCombinedFlags


  combinedFlags := CombineFlags 
  previousCombinedFlags := combinedFlags
  repeat until not lockset(debugLock)
  Pst.str(@modeMenuText)
  if combinedFlags
    Pst.str(@modifyMenu)
    if modifiableColorFlag
      Pst.str(@modifyColor)
    if modifiableNumberFlag
      Pst.str(@modifyNumber)
    if modifiableBrightnessFlag
      Pst.str(@modifyBrightness)
  lockclr(debugLock)
  'DumpBuffer(@displayBuffer, NUMBER_OF_LEDS)
  
  DisplayInfo
  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "O", "o":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          modifiableBrightnessFlag := 0
          ledMode := OFF_MODE
        "L", "l":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS - 1
          activeLedsLowerLimit := 1
          activeLeds <#= activeLedsUpperLimit
          activeLeds #>= activeLedsLowerLimit
          modifiableBrightnessFlag := 1
          ledMode := LARSON_MODE          
        "S", "s":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 0
          modifiableBrightnessFlag := 1
          ledMode := SOLID_MODE
        "D", "d":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS - 1
          activeLedsLowerLimit := 2
          modifiableBrightnessFlag := 1
          ledMode := DRAGON_MODE
        "T", "t":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS - 1
          activeLedsLowerLimit := 2
          modifiableBrightnessFlag := 1
          ledMode := TAIL_MODE 
        "R", "r":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS
          activeLedsLowerLimit := 0
          modifiableBrightnessFlag := 1
          ledMode := ROTATE_MODE
        "P", "p":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PULSE_MODE
        {"B", "b":
          modifiableColorFlag := 0
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS
          activeLedsLowerLimit := 2
          modifiableBrightnessFlag := 1
          ledMode := BOW_MODE       }
        "A", "a":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PATTERN_MODE
        "Y", "y":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := CYCLE_MODE
          
        "W", "w":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := WHITE_MODE

        "H", "h":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := RAINBOW_ANGLED_MODE
          
        "X", "x":
          modifiableColorFlag := 1
          modifiableNumberFlag := 0
          activeLedsUpperLimit := NUMBER_OF_RGB_LEDS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          menuMode := CHOOSE_TEXT_MENU
          ledMode := TEXT_MODE
          
        "C", "c":
          if modifiableColorFlag
            menuMode := CHOOSE_COLOR
        "N", "n":
          if modifiableNumberFlag
            menuMode := CHOOSE_NUMBER
        "+":
          if modifiableBrightnessFlag
            result := brightness + 1
            brightness :=  result <# DATA_RESOLUTION
        "-":
          if modifiableBrightnessFlag
            result := brightness - 1
            brightness :=  result #> DATA_RESOLUTION
        "*":
          if modifiableBrightnessFlag
            result := brightness + 10
            brightness :=  result <# DATA_RESOLUTION 
        "/":
          if modifiableBrightnessFlag
            result := brightness - 10
            brightness :=  result #> DATA_RESOLUTION

      combinedFlags := CombineFlags
      
  while menuMode == CHOOSE_MODE and combinedFlags == previousCombinedFlags
         
{PUB LoadTextOld(localPtr, localSize) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    localCharacter := byte[localPtr++]
    'Pst.char(44)
    'Pst.char(32)
    'Pst.char(localCharacter)
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      showFlag := 1
      
    else ' if not a character within font, use a space.
      localCharacter := 32
      showFlag := 1
    if showFlag == 1
      'ScrollHorizontal(2, 0, @fontSpace + (FONT_BYTES_PER_CHARACTER * (localCharacter - "A")))
       
      eeStart := EEPROM_FONT_ADDRESS + (FONT_BYTES_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
      Eeprom.ToRam(@fontSpace, @fontSpace + FONT_BYTES_PER_CHARACTER, eeStart)
      if localCharacter == 32
        ScrollHorizontalOld(DEFAULT_SPACE_BETWEEN_LETTERS, DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS, @fontSpace)
        'Pst.str(string("<space>"))
        'Pst.char("(")
        'Pst.dec(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
        'Pst.char(")")
        
        
      else
        ScrollHorizontalOld(DEFAULT_SPACE_BETWEEN_LETTERS, fontSpace[FONT_BYTES_PER_CHARACTER], @fontSpace)
      DumpBuffer(@displayBuffer, DISPLAY_BYTES, DISPLAY_BYTES_WIDTH)
      repeat until not lockset(debugLock)
      Pst.str(string(13, "localCharacter = ", 34))
      Pst.char(localCharacter)
      Pst.char(34)
      Pst.str(string(13, "font size = ", 34))
      Pst.dec(fontSpace[FONT_BYTES_PER_CHARACTER])
      Pst.str(string(13, "After displayBuffer dump.                                 "))
      Pst.str(string(13, "Press any key to dump fontSpace buffer.                   "))
      Pst.CharIn
      lockclr(debugLock)
      DumpBuffer(@fontSpace, FONT_BYTES_IN_EEPROM, DISPLAY_BYTES_WIDTH)
      repeat until not lockset(debugLock)
      Pst.str(string(13, "After fontSpace buffer dump.                       "))
      Pst.str(string(13, "Press any key to continue.                            "))
      Pst.CharIn
      lockclr(debugLock)
   { repeat until not lockset(debugLock)
    result := Pst.RxCount
    lockclr(debugLock)
    if result
      repeat until not lockset(debugLock)
      Pst.CharIn
      lockclr(debugLock)
      DumpBuffer(@displayBuffer, FONT_BYTES_IN_EEPROM, DISPLAY_BYTES_WIDTH)
      repeat until not lockset(debugLock)
      Pst.str(string(13, "Press any key to continue.                                               "))
      Pst.CharIn
      lockclr(debugLock)  } 
      
      'Pst.char("(")
      'Pst.dec(eeStart)
      'Pst.char(")")
}                                                                               
PUB LoadText(localPtr, localSize) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    if ledMode <> TEXT_MODE and ledMode <> RAINBOW_TEXT_MODE
      abort
    ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)
    localCharacter := byte[localPtr++]
    'Pst.char(44)
    'Pst.char(32)
    'Pst.char(localCharacter)
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      if localCharacter == 32
        ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      else
        eeStart := EEPROM_FONT_ADDRESS + (4 * FONT_LONGS_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
        'Eeprom.ToRam(@fontSpace, @fontSpace + (4 * FONT_LONGS_PER_CHARACTER) - 1, eeStart)
        Eeprom.ToRam(@fontSpace, @fontSpace + (4 * FONT_LONGS_IN_EEPROM) - 1, eeStart)
        if ledMode == RAINBOW_TEXT_MODE
          ScrollRainbowFontHorizontal
        else
          ScrollFontHorizontal
      
{{PUB LoadRainbowText(localPtr, localSize) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)
    localCharacter := byte[localPtr++]
    if ledMode <> RAINBOW_TEXT_MODE
      abort
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      if localCharacter == 32
        ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      else
        eeStart := EEPROM_FONT_ADDRESS + (4 * FONT_LONGS_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
        Eeprom.ToRam(@fontSpace, @fontSpace + (4 * FONT_LONGS_IN_EEPROM) - 1, eeStart)
        ScrollRainbowFontHorizontal
}}      
{{PUB LoadTextFont(localPtr, localSize, localFont) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)
    localCharacter := byte[localPtr++]
    if ledMode <> RAINBOW_TEXT_MODE
      abort
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      if localCharacter == 32
        ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      else
        eeStart := EEPROM_FONT_ADDRESS + (FONT_BYTES_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
        Eeprom.ToRam(@fontSpace, @fontSpace + FONT_BYTES_PER_CHARACTER, eeStart)
        ScrollRainbowFontHorizontal
}}      
PUB ScrollSpace(localSize) | dataToScrollIndex, displayRowIndex, firstLongOfRowPtr, lastOfRowIndex

  repeat dataToScrollIndex from 0 to localSize - 1
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      firstLongOfRowPtr := @displayBuffer + (4 * displayRowIndex * DISPLAY_LONGS_WIDTH)
      lastOfRowIndex := (displayRowIndex * DISPLAY_LONGS_WIDTH) + {
        } DISPLAY_LONGS_WIDTH - 1
      longmove(firstLongOfRowPtr, firstLongOfRowPtr + 4, DISPLAY_LONGS_WIDTH - 1)
      displayBuffer[lastOfRowIndex] := background
    
    Led.RefreshBuffer2D
    if dataToScrollIndex == localSize - 1
      Pause(shortenedScrollDelay)
    else  
      Pause(horizontalScrollDelay)
                                                                                 
PUB ScrollFontHorizontal| dataToScrollIndex, displayRowIndex, firstLongOfRowPtr, {
                        } lastOfRowIndex, fontColumnToDisplay, localSize

  localSize := fontSpace[FONT_LONGS_PER_CHARACTER]
  repeat dataToScrollIndex from 0 to localSize - 1
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      if ledMode <> TEXT_MODE
        abort
      firstLongOfRowPtr := @displayBuffer + (4 * displayRowIndex * DISPLAY_LONGS_WIDTH)
      lastOfRowIndex := (displayRowIndex * DISPLAY_LONGS_WIDTH) + {
        } DISPLAY_LONGS_WIDTH - 1
      fontColumnToDisplay := (displayRowIndex * FONT_EEPROM_LONGS_WIDTH) + {
        } dataToScrollIndex
      longmove(firstLongOfRowPtr, firstLongOfRowPtr + 4, DISPLAY_LONGS_WIDTH - 1)
      displayBuffer[lastOfRowIndex] := fontSpace[fontColumnToDisplay] 
  
    Led.RefreshBuffer2D
    Pause(horizontalScrollDelay)

PUB ScrollRainbowFontHorizontal| dataToScrollIndex, displayRowIndex, firstLongOfRowPtr, {
                        } lastOfRowIndex, fontColumnToDisplay, localSize

  'RAINBOW_TEXT_TRANSITIONS = 8
  'activeTextColor, colorCount
  'colorTransition[TRI_COLOR]
  'globalColor[TRI_COLOR]
  
  localSize := fontSpace[FONT_LONGS_PER_CHARACTER]
  repeat dataToScrollIndex from 0 to localSize - 1
    if ++colorCount == RAINBOW_TEXT_TRANSITIONS
      colorCount := 0
      result := activeTextColor
      if ++activeTextColor > FINAL_RAINBOW_COLOR 'VIOLET 
        activeTextColor := INITIAL_RAINBOW_COLOR 'RED
      

      'repeat until not lockset(debugLock)
      'Pst.str(string(13, "color = "))
      'Pst.str(GetColorName(activeTextColor))
      'lockclr(debugLock)
      'Pause(500)
       '*******************************
       '*** what is globalColor
      globalColor[RED_PORTION] := Led.GetRedPortion(blackSetting[result]) * 10
      globalColor[GREEN_PORTION] := Led.GetGreenPortion(blackSetting[result]) * 10 
      globalColor[BLUE_PORTION] := Led.GetBluePortion(blackSetting[result]) * 10 
      globalColor[INTENSITY_PORTION] := Led.GetIntensityPortion(blackSetting[result]) * 10 
      colorTransition[RED_PORTION] := ((Led.GetRedPortion(blackSetting[activeTextColor]) {
      } * 10) - globalColor[RED_PORTION])  / RAINBOW_TEXT_TRANSITIONS
      colorTransition[GREEN_PORTION] := ((Led.GetGreenPortion(blackSetting[activeTextColor]) {
      } * 10) - globalColor[GREEN_PORTION])  / RAINBOW_TEXT_TRANSITIONS
      colorTransition[BLUE_PORTION] := ((Led.GetBluePortion(blackSetting[activeTextColor]) {
      } * 10) - globalColor[BLUE_PORTION])  / RAINBOW_TEXT_TRANSITIONS
      colorTransition[INTENSITY_PORTION] := ((Led.GetIntensityPortion( {
      } blackSetting[activeTextColor]) * 10) - globalColor[INTENSITY_PORTION])  {
      } / RAINBOW_TEXT_TRANSITIONS
    else
      globalColor[RED_PORTION] += colorTransition[RED_PORTION]
      globalColor[GREEN_PORTION] += colorTransition[GREEN_PORTION]
      globalColor[BLUE_PORTION] += colorTransition[BLUE_PORTION]
      globalColor[INTENSITY_PORTION] += colorTransition[INTENSITY_PORTION]  
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      if ledMode <> RAINBOW_TEXT_MODE
        abort
     
  
      'displayBuffer[lastOfRowIndex] := fontSpace[fontColumnToDisplay] 

      firstLongOfRowPtr := @displayBuffer + (4 * displayRowIndex * DISPLAY_LONGS_WIDTH)
      lastOfRowIndex := (displayRowIndex * DISPLAY_LONGS_WIDTH) + {
        } DISPLAY_LONGS_WIDTH - 1
      fontColumnToDisplay := (displayRowIndex * FONT_EEPROM_LONGS_WIDTH) + {
        } dataToScrollIndex
      longmove(firstLongOfRowPtr, firstLongOfRowPtr + 4, DISPLAY_LONGS_WIDTH - 1)
      if fontSpace[fontColumnToDisplay] <> background
        displayBuffer[lastOfRowIndex] := Led.MakeColor(globalColor[RED_PORTION] / 10, {
        } globalColor[GREEN_PORTION] / 10, globalColor[BLUE_PORTION] / 10, {
        } globalColor[INTENSITY_PORTION] / 10)
      else
        displayBuffer[lastOfRowIndex] := background
      
    Led.RefreshBuffer2D
    Pause(horizontalScrollDelay)
      
PUB BuildFont(fontColor) : eeStart | characterIndex, widthIndex, heightIndex, rowOfFontBits, {
              } furthestRightBit, mostSigBit, bitToSubtract, wideFontIndex

  eeStart := EEPROM_FONT_ADDRESS
  repeat characterIndex from 0 to (HIGHEST_ASCII_USED - LOWEST_ASCII_USED)'25 '65 to 90
    longfill(@fontSpace, background, FONT_LONGS_PER_CHARACTER)
    furthestRightBit := FONT_WIDTH
    repeat heightIndex from 0 to FONT_HEIGHT - 1
      rowOfFontBits := byte[@freeDesign032 + (characterIndex * FONT_HEIGHT) + heightIndex]
      ''Pst.str(string(13, "rowOfFontBits = %"))
      'Pst.dec( rowOfFontBits)
      ''Pst.bin(rowOfFontBits, 8)
      'Pst.str(string(", bytes = "))
      repeat 
        mostSigBit := >|rowOfFontBits
        'Pst.str( string(13, "mostSigBit = "))
        {Pst.char("(")
        Pst.dec(mostSigBit)
        Pst.char(")")
        Pst.char(" ")
        }
        if mostSigBit <> 0
          if mostSigBit < furthestRightBit
            furthestRightBit := mostSigBit
          fontSpace[(8 * heightIndex) + (8 - mostSigBit)] := blackSetting[fontColor]
        
          {Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + RED_PORTION], 8)
          Pst.char(",")
          Pst.char(" ")
          Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + GREEN_PORTION], 8)
          Pst.char(",")
          Pst.char(" ")
          Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + BLUE_PORTION], 8)
          Pst.char(",")
          Pst.char(" ") }
          {Pst.str( string(13, "fontSpace["))
          Pst.dec( (FONT_WIDTH * heightIndex) + (8 - mostSigBit))
          Pst.str( string("] = "))
          Pst.dec( globalBrightness)  }
          bitToSubtract := 1
          bitToSubtract <<= (mostSigBit - 1)
          rowOfFontBits -= bitToSubtract
      while mostSigBit <> 0
      'Pst.char(13)
      
    fontSpace[FONT_LONGS_PER_CHARACTER] := 9 - furthestRightBit
    ''Pst.str(string(13, "Font is "))
    ''Pst.dec(fontSpace[FONT_LONGS_PER_CHARACTER])
    ''Pst.str(string(" pixels wide."))
    Eeprom.FromRam(@fontSpace, @fontSpace + (4 * FONT_LONGS_IN_EEPROM) - 1, eeStart)
    Pst.str( string(13, "eeStart = "))
    Pst.dec(eeStart)
    eeStart += 4 * FONT_LONGS_IN_EEPROM
    'longfill(@fontSpace, background, FONT_LONGS_IN_EEPROM)
    
  'Eeprom.FromRam(@fontSpace, @fontSpace + 120, eeStart)
  'Pst.str( string(13, "last eeStart = "))
  'Pst.dec( eeStart)
  {
  repeat characterIndex from 0 to (HIGHEST_ASCII_USED - LOWEST_ASCII_USED)
    repeat wideFontIndex from 0 to _WideFontCount - 1
      if characterIndex == wideFontAscii[wideFontIndex] - LOWEST_ASCII_USED
        'Pst.str( string(13, "Building a wide font."))
        eeStart := EEPROM_FONT_ADDRESS + (characterIndex * 121)
        furthestRightBit := 16
          repeat heightIndex from 0 to 9
            'rowOfFontBits := word[@freeDesignWide087 + (wideFontIndex * 20) + (heightIndex * 2)]
            rowOfFontBits := freeDesignWide087[(wideFontIndex * 10) + heightIndex]
            Pst.str(string(13, "Wide rowOfFontBits = "))
            Pst.dec(rowOfFontBits)
            Pst.str(string(", = %"))
            Pst.bin(rowOfFontBits, 16)
            repeat 
              mostSigBit := >|rowOfFontBits
              'Pst.str( string(13, "mostSigBit = "))
              'Pst.dec( mostSigBit)
              if mostSigBit <> 0
                if mostSigBit < furthestRightBit
                  furthestRightBit := mostSigBit
                byte[@fontSpace + (FONT_WIDTH * heightIndex) + (16 - mostSigBit) {+ 4}] := globalBrightness
                {Pst.str( string(13, "fontSpace["))
                Pst.dec( (FONT_WIDTH * heightIndex) + (8 - mostSigBit))
                Pst.str( string("] = "))
                Pst.dec( globalBrightness)  }
                bitToSubtract := 1
                bitToSubtract <<= (mostSigBit - 1)
                rowOfFontBits -= bitToSubtract
            while mostSigBit <> 0
            'Pst.char(13)
            'repeat localIndex[2] from 0 to FONT_WIDTH - 2
              'Pst.dec(byte[@fontSpace + (FONT_WIDTH * heightIndex) + localIndex[2]])
              'Pst.char(44)
              'Pst.char(32)
            'Pst.dec(byte[@fontSpace + (FONT_WIDTH * heightIndex) + FONT_WIDTH - 1])
          fontSpace[120] := 17 - furthestRightBit
          Pst.str( string(13, "Font is "))
          Pst.dec( fontSpace[120])
          Pst.str( string(" pixels wide."))
          Eeprom.FromRam(@fontSpace, @fontSpace + 120, eeStart)
          Pst.str( string(13, "eeStart = "))
          Pst.dec( eeStart)
          eeStart += 121
          bytefill(@fontSpace, 0, 121)
  bytefill(@displayBuffer, 0, 240)
  }
PUB ColorMenu | localCharacter, combinedFlags, previousCombinedFlags

  
  repeat until not lockset(debugLock)
  Pst.str(@colorMenuText)
  lockclr(debugLock)

  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "R", "r":
          activeColor := RED
          menuMode :=CHOOSE_MODE
        "O", "o":
          activeColor := ORANGE
          menuMode :=CHOOSE_MODE
        "Y", "y":
          activeColor := YELLOW
          menuMode :=CHOOSE_MODE
        "G", "g":
          activeColor := GREEN
          menuMode :=CHOOSE_MODE
        "B", "b":
          activeColor := BLUE
          menuMode :=CHOOSE_MODE
        "I", "i":
          activeColor := INDIGO
          menuMode :=CHOOSE_MODE
        "V", "v":
          activeColor := VIOLET
          menuMode :=CHOOSE_MODE
        "W", "w":
          activeColor := WHITE
          menuMode :=CHOOSE_MODE
      
  while menuMode == CHOOSE_COLOR
           
PUB EnterNumber

  repeat until not lockset(debugLock)
  Pst.str(@numberMenuText)
  Pst.dec(activeLedsLowerLimit)
  Pst.str(string(" and "))
  Pst.dec(activeLedsUpperLimit)
  Pst.str(string(".        "))
  
  result := Pst.DecIn
  
  Pst.str(string(13, "You entered "))
  Pst.dec(result)
  Pst.str(string(". ", 13))
  if result < activeLedsLowerLimit
    Pst.dec(result)
    Pst.str(string(" is less than the limit of "))
    Pst.dec(activeLedsLowerLimit)
    Pst.str(string(". ", 13))
    Pst.str(string("The value "))
    Pst.dec(activeLedsLowerLimit)
    Pst.str(string(" will be used instead of "))
    Pst.dec(result)
    Pst.str(string(". ", 13))
    result := activeLedsLowerLimit
  elseif result > activeLedsUpperLimit
    Pst.dec(result)
    Pst.str(string(" is greater than the limit of "))
    Pst.dec(activeLedsUpperLimit)
    Pst.str(string(". ", 13))
    Pst.str(string("The value "))
    Pst.dec(activeLedsUpperLimit)
    Pst.str(string(" will be used instead of "))
    Pst.dec(result)
    Pst.str(string(". ", 13))
    result := activeLedsUpperLimit
  activeLeds := result
  lockclr(debugLock)
  menuMode :=CHOOSE_MODE
  
PUB CombineFlags

  result := modifiableColorFlag << 2
  result += modifiableNumberFlag << 1
  result += modifiableBrightnessFlag

PRI LightLeds | timeInterval, localPreviousMode, previousColor, previousBrightness, {
              } previousActiveLeds, localSize
 
  localPreviousMode := -1
  previousColor := -1
  previousBrightness := -1
  previousActiveLeds := -1
  
  'lastLedModeDisplayed := localPreviousMode
  'ledCog := Led.Start(12, @displayBuffer) - 1
  '#0, OFF_MODE, LARSON_MODE, SOLID_MODE, DRAGON_MODE, TAIL_MODE, ROTATE_MODE, PULSE_MODE, BOW_MODE
    'PATTERN_MODE, CYCLE_MODE
  'lastDisplayTime := cnt
  repeat
    'RefreshDisplay
    
    
    if ledMode <> localPreviousMode or activeColor <> previousColor or {
     } brightness <> previousBrightness or activeLeds <> previousActiveLeds                  
      localPreviousMode := ledMode
      previousColor := activeColor
      previousBrightness := brightness
      previousActiveLeds := activeLeds
      case ledMode         
        OFF_MODE:
          'activeLedsUpperLimit := NUMBER_OF_RGB_LEDS
          'activeLedsLowerLimit := NUMBER_OF_RGB_LEDS
          'Solid(BLACK)
          longfill(@displayBuffer, 0, NUMBER_OF_LEDS)
        LARSON_MODE:
          CylonLeds        
        SOLID_MODE:
          'Solid(activeColor)
          FillDisplay(activeColor, brightness)
        DRAGON_MODE:
          FillTail(activeLeds)
          RotateTail
        TAIL_MODE:
          FillTail(activeLeds)
          BounceTail
        ROTATE_MODE:
          RotateBuffer(1)
        PULSE_MODE:
          Pulse         
        {{BOW_MODE:
        RAINBOW_ANGLED_MODE:
          RainbowAngled(1)  }}
        {{PATTERN_MODE:
          Pattern }}
        CYCLE_MODE:
          CycleColors
        TEXT_MODE:
          localSize := strsize(@messageBuffer0)
          ScrollMessage(@messageBuffer0, localSize)
        UPDATE_TEXT_MODE:
          ledMode := TEXT_MODE
        RAINBOW_TEXT_MODE:
          localSize := strsize(@messageBuffer0)
          ScrollMessage(@messageBuffer0, localSize)  
        WHITE_MODE:
          WhiteAll
          ' reload messageBuffer
        'other: localPreviousMode := CaseUltrasound(ledMode, localPreviousMode)
{
PUB NumbersToColors(value) | bufferPtr[2], singleDigit, numberToChop, localIndex

  value <#= 9999
  value #>= 0
  if value <> coloredNumber
    coloredNumber := value
    
    bufferPtr[0] := @displayBuffer + NUMBERS_TO_COLORS_OFFSET
    bufferPtr[1] := @altLedBuffer0 + NUMBERS_TO_COLORS_OFFSET
    numberToChop := value
    result := 1000
    localIndex := 0
    repeat 4
      singleDigit := value / result
      bytemove(bufferPtr[0], @colorSet0 + (singleDigit * 3), 3)
      bytemove(bufferPtr[1], @colorSet1 + (singleDigit * 3), 3)
      repeat until not lockset(debugLock)
      Pst.Position(LED_NUMBER_READING_X + (localIndex++ * 3), LED_NUMBER_READING_Y)
      'Pst.str(string(", ["))
      'Pst.dec(localIndex) 
      'Pst.str(string("] = "))
      Pst.dec(singleDigit)
      Pst.str(string(" "))
      lockclr(debugLock)  
      bufferPtr[0] -= 3
      bufferPtr[1] -= 3
      value //= result   
      result /= 10
      
  if bufferInUsePtr == altLedBuffer0
    bufferInUsePtr := @displayBuffer
  else  
    bufferInUsePtr := @altLedBuffer0

  bytemove(@displayBuffer, bufferInUsePtr, NUMBER_OF_LEDS)
}    
PRI WhiteAll | ledIndex, colorIndex
 
  repeat ledIndex from 0 to DISPLAY_PIXELS - 1
    displayBuffer[(ledIndex * TRI_COLOR) + RED_PORTION] := 255
    displayBuffer[(ledIndex * TRI_COLOR) + GREEN_PORTION] := 255
    displayBuffer[(ledIndex * TRI_COLOR) + BLUE_PORTION] := 255
          
{{PRI RainbowAngled(colorWidth) | ledIndex, colorIndex[3]

  longfill(@colorIndex, 0, 3)
  repeat
    if ++colorCount == RAINBOW_TEXT_TRANSITIONS
      colorCount := 0
      result := activeTextColor
      if ++activeTextColor > VIOLET 'WHITE
        activeTextColor := RED
      

      'repeat until not lockset(debugLock)
      'Pst.str(string(13, "color = "))
      'Pst.str(GetColorName(activeTextColor))
      'lockclr(debugLock)
      'Pause(500)
        
      globalColor[RED_PORTION] := blackSetting[(result * TRI_COLOR) + RED_PORTION] * 10
      globalColor[GREEN_PORTION] := blackSetting[(result * TRI_COLOR) + GREEN_PORTION] * 10
      globalColor[BLUE_PORTION] := blackSetting[(result * TRI_COLOR) + BLUE_PORTION] * 10
      colorTransition[RED_PORTION] := ((blackSetting[(activeTextColor * TRI_COLOR) + {
        }RED_PORTION] * 10) - globalColor[RED_PORTION])  / RAINBOW_TEXT_TRANSITIONS
      colorTransition[BLUE_PORTION] := ((blackSetting[(activeTextColor * TRI_COLOR) + {
        }BLUE_PORTION] * 10) - globalColor[BLUE_PORTION]) / RAINBOW_TEXT_TRANSITIONS
      colorTransition[GREEN_PORTION] := ((blackSetting[(activeTextColor * TRI_COLOR) + {
        }GREEN_PORTION] * 10) - globalColor[GREEN_PORTION]) / RAINBOW_TEXT_TRANSITIONS
    else
      globalColor[RED_PORTION] += colorTransition[RED_PORTION]
      globalColor[BLUE_PORTION] += colorTransition[BLUE_PORTION]
      globalColor[GREEN_PORTION] += colorTransition[GREEN_PORTION]
      
    {colorIndex[RED_PORTION] += 32
    if colorIndex[RED_PORTION] > 255
      colorIndex[RED_PORTION] := 0                               
      colorIndex[BLUE_PORTION] += 32
      if colorIndex[BLUE_PORTION] > 255
        colorIndex[BLUE_PORTION] := 0
        colorIndex[GREEN_PORTION] += 32
        if colorIndex[GREEN_PORTION] > 255
          longfill(@colorIndex, 0, 3) }
    bytemove(@displayBuffer + DISPLAY_BYTES_WIDTH, @displayBuffer, DISPLAY_BYTES - DISPLAY_BYTES_WIDTH)
    bytemove(@displayBuffer, @displayBuffer + (colorWidth  * TRI_COLOR), DISPLAY_BYTES_WIDTH - (colorWidth  * TRI_COLOR))    
    repeat ledIndex from 0 to colorWidth - 1
      displayBuffer[DISPLAY_BYTES_WIDTH - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + RED_PORTION] := globalColor[RED_PORTION] / 10
      displayBuffer[DISPLAY_BYTES_WIDTH - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + BLUE_PORTION] := globalColor[BLUE_PORTION] / 10
      displayBuffer[DISPLAY_BYTES_WIDTH - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + GREEN_PORTION] := globalColor[GREEN_PORTION] / 10
    Pause(horizontalScrollDelay) 
  while ledMode == RAINBOW_ANGLED_MODE
}}     
PUB FillTail(localLeds) | deltaBright, localBrightness

  deltaBright := ((brightness + 1) * 100) / localLeds
  localBrightness := 0
  bytefill(@displayBuffer, 0, NUMBER_OF_LEDS) 
  repeat result from 0 to localLeds - 1 ' * 3) - 1 step 3
    localBrightness += deltaBright
    displayBuffer[(result * 3) + RED_PORTION] := ((blackSetting[(activeColor * 3) + RED_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100 
    displayBuffer[(result * 3) + GREEN_PORTION] := ((blackSetting[(activeColor * 3) + GREEN_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100
    displayBuffer[(result * 3) + BLUE_PORTION] := ((blackSetting[(activeColor * 3) + BLUE_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100

  DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
  repeat until not lockset(debugLock)
  Pst.str(string(13, "deltaBright = "))
  Pst.dec(deltaBright)
  lockclr(debugLock)     
  'repeat  
PUB RotateBuffer(rotationAmount) '| totalToRotate

  if rotationAmount > 0
    bytemove(@tempBuffer, @displayBuffer, rotationAmount * ledType)
    bytemove(@displayBuffer, @displayBuffer + (ledType * rotationAmount), (NUMBER_OF_RGB_LEDS - rotationAmount) * ledType)
    bytemove(@displayBuffer + (ledType * (NUMBER_OF_RGB_LEDS - rotationAmount)), @tempBuffer, rotationAmount * ledType)
  else
    bytemove(@tempBuffer, @displayBuffer + (ledType * (NUMBER_OF_RGB_LEDS - rotationAmount)), rotationAmount * ledType)
    bytemove(@displayBuffer + (ledType * rotationAmount), @displayBuffer, (NUMBER_OF_RGB_LEDS - rotationAmount) * ledType)
    bytemove(@displayBuffer, @tempBuffer, rotationAmount * ledType)
  {DumpBuffer(@displayBuffer, NUMBER_OF_LEDS)
  repeat until not lockset(debugLock)
  Pst.str(string(13, "@tempBuffer = "))
  Pst.dec(@tempBuffer)
  Pst.str(string(13, "@displayBuffer = "))
  Pst.dec(@displayBuffer)
  Pst.str(string(13, "@displayBuffer + (ledType * rotationAmount) = "))
  Pst.dec(@displayBuffer + (ledType * rotationAmount))
  Pst.str(string(13, "(NUMBER_OF_RGB_LEDS - rotationAmount) * ledType = "))
  Pst.dec((NUMBER_OF_RGB_LEDS - rotationAmount) * ledType)
  Pst.str(string(13, "@displayBuffer + (ledType * (NUMBER_OF_RGB_LEDS - rotationAmount)) = "))
  Pst.dec(@displayBuffer + (ledType * (NUMBER_OF_RGB_LEDS - rotationAmount)))
  Pst.str(string(13, "result = "))
  Pst.dec(result)
  lockclr(debugLock)
  Pst.charIn     }
  
PUB RotateTail | localColor, localBrightness, localActiveLeds

  localColor := activeColor
  localBrightness := brightness
  localActiveLeds := activeLeds
  repeat 
    RotateBuffer(1)
    Pause(shortPause)
  while ledMode == DRAGON_MODE and activeColor == localColor and {
  } brightness == localBrightness and activeLeds == localActiveLeds
  
PUB BounceTail | localColor, localBrightness, localActiveLeds, localIndex
' needs a lot of help. full of bugs.

  localColor := activeColor
  localBrightness := brightness
  localActiveLeds := activeLeds
  bytemove(@altLedBuffer0, @displayBuffer, activeLeds * ledType)
  repeat localIndex from 0 to activeLeds - 1
    altLedBuffer1[localIndex] :=  altLedBuffer0[(activeLeds - 1) - localIndex]
  DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
  Pst.charIn  
  repeat  
    repeat NUMBER_OF_RGB_LEDS - activeLeds
      RotateBuffer(1)
      Pause(shortPause)
    repeat result from 1 to activeLeds '(activeLeds + 1) / 2
      bytemove(@displayBuffer + (ledType * (NUMBER_OF_RGB_LEDS - result)), @altLedBuffer0, (ledType * (activeLeds - result)))
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
      Pst.charIn  
      repeat localIndex from 1 to result
        displayBuffer[(NUMBER_OF_RGB_LEDS * ledType) - localIndex] := altLedBuffer1[result - 1]
        Pause(shortPause)
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
      Pst.charIn    
    repeat NUMBER_OF_RGB_LEDS - activeLeds
      RotateBuffer(-1)
      Pause(shortPause)
    repeat result from 1 to activeLeds '(activeLeds + 1) / 2
      bytemove(@displayBuffer, @altLedBuffer1 + result, (ledType * (activeLeds - result)))
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
      Pst.charIn  
      repeat localIndex from 0 to result - 1
        displayBuffer[localIndex] := altLedBuffer1[localIndex + result]
        Pause(shortPause)
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)
      Pst.charIn    
  while ledMode == TAIL_MODE and activeColor == localColor and {
  } brightness == localBrightness and activeLeds == localActiveLeds
  
PUB Pulse | localColor, localBrightness, localActiveLeds, pulseIndex, localLightLevel

  localColor := activeColor
  localBrightness := brightness
  localActiveLeds := activeLeds

  bytemove(@altLedBuffer0, @displayBuffer, NUMBER_OF_LEDS) 
  repeat
    repeat localLightLevel from 0 to DATA_RESOLUTION - 1    
      repeat result from 0 to NUMBER_OF_LEDS
        displayBuffer[result] := (altLedBuffer0[result] * localLightLevel) / (DATA_RESOLUTION - 1)
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)    
    repeat localLightLevel from DATA_RESOLUTION - 2 to 1    
      repeat result from 0 to NUMBER_OF_LEDS
        displayBuffer[result] := (altLedBuffer0[result] * localLightLevel) / (DATA_RESOLUTION - 1)
      DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)      
  while ledMode == PULSE_MODE and activeColor == localColor and {
  } brightness == localBrightness and activeLeds == localActiveLeds
  
PUB Flash(localColor, localIndex, delay) | waitTime

  'previousBufferInUsePtr := bufferInUsePtr
  delay *= millisecond
  
  repeat result from 0 to NUMBER_OF_LEDS - 1 step 3
    tempBuffer[result + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION]
    tempBuffer[result + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION]
    tempBuffer[result + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION]
  waitTime := cnt 
  repeat localIndex
    'RefreshDisplay
    bytemove(@displayBuffer, @tempbuffer, NUMBER_OF_LEDS) 
    waitcnt(waitTime += delay)
    bytefill(@displayBuffer, 0, NUMBER_OF_LEDS)
    waitcnt(waitTime += delay)
  'bufferInUsePtr := previousBufferInUsePtr
  'bytemove(@displayBuffer, bufferInUsePtr, NUMBER_OF_LEDS) 
  ledMode := previousLedMode
   
{PUB Solid(localColor) | waitTime

  {repeat until not lockset(debugLock)
  Pst.str(GetColorName(activeColor))
  lockclr(debugLock)   }    
  repeat result from 0 to NUMBER_OF_LEDS - 1 step 3
    displayBuffer[result + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION 
    displayBuffer[result + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION 
    displayBuffer[result + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION 
  DumpBuffer(@displayBuffer, NUMBER_OF_LEDS)
}    
{PUB Chase(localColor, ledsToLight, direction) | localMode, waitTime, delay, tailLeds, localIndex

  delay := flashDurationMs * millisecond
  localMode := ledMode
  bytefill(@displayBuffer, 0, NUMBER_OF_LEDS)
  result := (NUMBER_OF_RGB_LEDS / ledsToLight) * 3
  
  localIndex := 0
  repeat  
    displayBuffer[localIndex + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION]
    displayBuffer[localIndex + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION]
    displayBuffer[localIndex + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION]
    localIndex += result
  while localIndex < NUMBER_OF_LEDS - 1  
  waitTime := cnt
  
  if direction == COUNTER_CLOCKWISE 
    repeat while ledMode == localMode
      'RefreshDisplay
      waitcnt(waitTime += delay)
      bytemove(@tailLeds, @displayBuffer, 3)
      bytemove(@displayBuffer, @displayBuffer + 3, NUMBER_OF_LEDS - 3)
      bytemove(@displayBuffer + NUMBER_OF_LEDS - 3 , @tailLeds, 3)
  else
    repeat while ledMode == localMode
      'RefreshDisplay
      waitcnt(waitTime += delay)
      bytemove(@tailLeds, @displayBuffer + NUMBER_OF_LEDS - 3, 3)
      bytemove(@displayBuffer + 3, @displayBuffer, NUMBER_OF_LEDS - 3)
      bytemove(@displayBuffer, @tailLeds, 3)

}        
PUB CylonLeds | timeInterval
 
  longfill(@displayBuffer, background, NUMBER_OF_RGB_LEDS)
  'result := activeLeds
  'activeLeds := 1
  'Solid(activeColor)
  'activeLeds := result
  result := -1
  displayBuffer[0] := blackSetting[activeColor]
  repeat
    repeat NUMBER_OF_RGB_LEDS - 1
      Led.ShiftBuffer(result)
      Pause(shortPause)
      'DumpBuffer(@displayBuffer, NUMBER_OF_LEDS, 24)  
    result *= -1 
  while ledMode == LARSON_MODE
       
'PUB RainbowLeds | timeInterval

'  repeat while ledMode == BOW_MODE

PUB CycleColors | localBrightness, colorIndex, brightnessIndex

  localBrightness := brightness
  
  repeat
    repeat colorIndex from RED to WHITE
      repeat brightnessIndex from 0 to 255 'step 4
        pause(10)
        FillDisplay(colorIndex, brightnessIndex)
        if ledMode <> CYCLE_MODE or brightness <> localBrightness
          return
  while ledMode == CYCLE_MODE and brightness == localBrightness
  
PUB FillDisplay(colorIndex, brightnessIndex) | ledIndex

  repeat ledIndex from 0 to DISPLAY_PIXELS - 1
    result := (blackSetting[(TRI_COLOR * colorIndex) + RED_PORTION] * {
      } (brightnessIndex + 1)) / DATA_RESOLUTION
    displayBuffer[(ledIndex * TRI_COLOR) + RED_PORTION] := result
    {if ledIndex // 6 == 0
      repeat until not lockset(debugLock)
      'Pst.char(13)
      'Pst.char(32)
      Pst.char(",")
      Pst.char(32)
      Pst.dec(ledIndex)
      Pst.char(",")
      Pst.char(32)
      Pst.dec(result)        
      lockclr(debugLock) }
    result := (blackSetting[(TRI_COLOR * colorIndex) + GREEN_PORTION] * {
      } (brightnessIndex + 1)) / DATA_RESOLUTION
    displayBuffer[(ledIndex * TRI_COLOR) + GREEN_PORTION] := result
    {if ledIndex // 6 == 0
      repeat until not lockset(debugLock)
      Pst.char(",")
      Pst.char(32)
      Pst.dec(result)        
      lockclr(debugLock)}  
    result := (blackSetting[(TRI_COLOR * colorIndex) + BLUE_PORTION] * {
      } (brightnessIndex + 1)) / DATA_RESOLUTION
    displayBuffer[(ledIndex * TRI_COLOR) + BLUE_PORTION] := result
    {if ledIndex // 6 == 0
      repeat until not lockset(debugLock)
      Pst.char(",")
      Pst.char(32)
      Pst.dec(result)        
      lockclr(debugLock) }
    
{{PUB Pattern | localBrightness, direction

  localBrightness := brightness
  direction := 1
  
  repeat
    repeat result from 200 to 50 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    repeat result from 60 to 190 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    direction *= -1
  while ledMode == PATTERN_MODE and brightness == localBrightness
}}
{{PUB PatternCycle(betweenPatternDelay, direction)
 
  if direction > 0
    repeat result from 0 to 11
      bytemove(@displayBuffer, @patternD00 + (result * DISPLAY_BYTES), DISPLAY_BYTES)
      pause(betweenPatternDelay)
      if ledMode <> PATTERN_MODE
        abort
  else
    repeat result from 0 to 11
      bytemove(@displayBuffer, @patternD11 - (result * DISPLAY_BYTES), DISPLAY_BYTES)
      pause(betweenPatternDelay)  
      if ledMode <> PATTERN_MODE
        abort
}}        
{PUB ScrollMessage(localPtr, localSize)

  repeat until not lockset(debugLock)
  Pst.str(string(13, "Start ScrollMessage Method"))
  Pst.str(string(13, "Message to scroll ", 34))
  Pst.str(localPtr)
  Pst.char(34)
  lockclr(debugLock) 
  repeat
    \LoadText(localPtr, localSize)
  while ledMode == TEXT_MODE     
  repeat until not lockset(debugLock)
  Pst.str(string(13, "End ScrollMessage Method"))
  lockclr(debugLock) 
}          
PUB ScrollMessage(localPtr, localSize)

  'globalColor[RED_PORTION] := whiteSetting[RED_PORTION]
  'globalColor[GREEN_PORTION] := whiteSetting[GREEN_PORTION]
  'globalColor[BLUE_PORTION] := whiteSetting[BLUE_PORTION]
  activeTextColor := WHITE - 2
  colorCount := RAINBOW_TEXT_TRANSITIONS - 1 ' so it will rollover to zero in first loop
  repeat
    \LoadText(localPtr, localSize)
  while ledMode == RAINBOW_TEXT_MODE or ledMode == TEXT_MODE 

PUB TextMenu | updateMenuFlag, localCharacter

  updateMenuFlag := 0
  repeat until not lockset(debugLock)
  Pst.str(@textMenuText)
  if bufferSavedFlag == 0
    Pst.str(@notSavedWarningText)
  else
    Pst.str(@savedText)
  lockclr(debugLock)
  
  repeat
    repeat until not lockset(debugLock)    
    localCharacter := Pst.RxCount
    lockclr(debugLock)
    if localCharacter
      repeat until not lockset(debugLock)
      localCharacter := Pst.CharIn
      lockclr(debugLock)
        
      case localCharacter
        "D", "d":
          ledMode := TEXT_MODE
          menuMode := CHOOSE_TEXT_MENU
        "N", "n":
          menuMode := CHOOSE_TEXT_MESSAGE
        "S", "s":
          SaveMessage
          updateMenuFlag := 1
        "R", "r":
          menuMode := CHOOSE_MODE
        "C", "c":
          ledMode := RAINBOW_TEXT_MODE
          'updateMenuFlag := 1
        "X", "x":
          menuMode :=CHOOSE_MODE
              
  while menuMode == CHOOSE_TEXT_MENU and updateMenuFlag == 0
  
  
{CHOOSE_TEXT_MENU: 
      CHOOSE_TEXT_MESSAGE: 
      CHOOSE_CONFIRM_MESSAGE:
 }
PUB EnterText | localCharacter

  repeat until not lockset(debugLock)
  Pst.str(@newTextMenuText)
  lockclr(debugLock)


  Pst.StrInMax(@messageBuffer, Pst#MAXSTR_LENGTH)  '** Can larger strings be entered?
  
  menuMode := CHOOSE_CONFIRM_MESSAGE
  bufferSavedFlag := 0

PUB SaveMessage

  repeat until not lockset(debugLock)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, "Saving message #"))
  Pst.dec(++messagesSavedCount)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, 34))
  Pst.str(@messageBuffer)
  Pst.char(34)
  Pst.char(13)
  lockclr(debugLock)

  messageSize[messagesSavedCount] := strsize(@messageBuffer)
  
  messageLocation[messagesSavedCount] := nextFreeEepromLoc
  
  messageSize[0] := strsize(@messageBuffer)
  Eeprom.FromRam(@messageLocation + (4 * (messagesSavedCount - 1)), @messageLocation + (4 * (messagesSavedCount - 1)) + 3, @messageLocation + (4 * (messagesSavedCount - 1)))
  Eeprom.FromRam(@messageSize + messagesSavedCount - 1, @messageSize + messagesSavedCount {
    } - 1, @messageSize + messagesSavedCount - 1)
  messagesSavedCount := 1
  Eeprom.FromRam(@messageBuffer, @messageBuffer + messageSize[messagesSavedCount] - 1, nextFreeEepromLoc)
  Eeprom.FromRam(@nextFreeEepromLoc, @nextFreeEepromLoc + 3, @nextFreeEepromLoc)
  nextFreeEepromLoc += messageSize[messagesSavedCount]
  bufferSavedFlag := 1
  
  
DAT

textMenuText            byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Text Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please select text option.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "D) Display current buffer.", 13
                        byte Pst#PX, MENU_DISPLAY_X, "N) Enter new text to buffer.", 13
                        byte Pst#PX, MENU_DISPLAY_X, "S) Save current buffer to EEPROM", 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Retreive text from EEPROM", 13
                        byte Pst#PX, MENU_DISPLAY_X, "X) Exit text menu", 13, 0

newTextMenuText         byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Enter Text", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please enter text to display", 13
                        byte Pst#PX, MENU_DISPLAY_X, "followed by the ", 34, "Enter", 34, " key.", 13, 13, 0

confirmTextText         byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "You entered", 13, 0
                       
notSavedWarningText     byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **           Warning!             **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   The text in the message      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   buffer has not been saved.   **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13, 0
                           
savedText               byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   The text in the message      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   buffer has been saved to     **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   EEPROM.                      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13, 0
                        
PUB ConfirmText | localCharacter

  repeat until not lockset(debugLock)
  Pst.str(@confirmTextText)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, 34))
  Pst.str(@messageBuffer)
  Pst.str(string(34, 13, 13, Pst#PX, MENU_DISPLAY_X, "Is this correct? ("))
  Pst.str(string(34, "Y", 34, " or ", 34, "N", 34, ")", 13))
  lockclr(debugLock)

  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "Y", "y":
          ledMode := UPDATE_TEXT_MODE
          menuMode := CHOOSE_TEXT_MENU
          bufferSavedFlag := 0
        "N", "n":
          menuMode := CHOOSE_TEXT_MESSAGE
        "X", "x":
          menuMode := CHOOSE_TEXT_MENU
                            
VAR

  long messageLocation[MAX_NUMBER_OF_MESSAGES], messagesSavedCount
  byte messageSize[MAX_NUMBER_OF_MESSAGES]
  byte bufferSavedFlag
  
PUB Pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1792                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
    
PUB DisplayInfo

  repeat until not lockset(debugLock)
  Pst.Position(MODE_DISPLAY_X, MODE_DISPLAY_Y)
  Pst.str(GetModeName(ledMode))

  Pst.Position(ACTIVE_COLOR_DISPLAY_X, ACTIVE_COLOR_DISPLAY_Y)
  Pst.str(GetColorName(activeColor))

  Pst.Position(ACTIVE_LEDS_DISPLAY_X, ACTIVE_LEDS_DISPLAY_Y)
  Pst.dec(activeLeds)  
  Pst.Position(ACTIVE_BRIGHTNESS_DISPLAY_X, ACTIVE_BRIGHTNESS_DISPLAY_Y)
  Pst.dec(brightness)  
  lockclr(debugLock)

PRI GetModeName(localMode)

  case localMode        
    OFF_MODE:
      result := string("OFF_MODE   ")
    LARSON_MODE:
      result := string("LARSON_MODE")        
    SOLID_MODE:
      result := string("SOLID_MODE ")
    DRAGON_MODE:
      result := string("DRAGON_MODE")
    TAIL_MODE:
      result := string("TAIL_MODE  ")
    ROTATE_MODE:
      result := string("ROTATE_MODE")
    PULSE_MODE:
      result := string("PULSE_MODE ")
    BOW_MODE:
      result := string("BOW_MODE")
    other:
      result := string("other mode ")


PRI GetColorName(localColor)

  case localColor
    RED:
      result := string("RED   ")
    ORANGE:
      result := string("ORANGE")
    YELLOW:
      result := string("YELLOW")
    GREEN:
      result := string("GREEN ")
    BLUE:
      result := string("BLUE  ")
    INDIGO:
      result := string("INDIGO")
    VIOLET:
      result := string("VIOLET")
    WHITE:
      result := string("WHITE ")
    BLACK:
      result := string("BLACK ")
    other:
      result := string("other ")
      
PUB DumpBuffer(localPtr, localSize, localColumns) | bufferIndex

  repeat until not lockset(debugLock)
  Pst.Position(TITLE_X, BUFFER_DUMP_Y)
  Pst.str(string("displayBuffer buffer dump:", 13))
  repeat bufferIndex from 0 to localSize - 1
    if bufferIndex // localColumns == 0
      Pst.Char(13)
    Pst.Char(32)  
    Pst.Char("$")  
    Pst.hex(byte[localPtr + bufferIndex], 2)
  lockclr(debugLock)
  
DAT

background              long DEFAULT_BACKGROUND 'COLOR_OTHER_WHITE
blackSetting            long COLOR_BLACK 
redSetting              long COLOR_RED
orangeSetting           long COLOR_ORANGE
yellowSetting           long COLOR_YELLOW
greenSetting            long COLOR_GREEN
blueSetting             long COLOR_BLUE
violetSetting           long COLOR_VIOLET
whiteSetting            long COLOR_WHITE '255, 255, 255 'WHITE_R, WHITE_G, WHITE_B
indigoSetting           long COLOR_INDIGO
cyanSetting             long COLOR_CYAN
otherWhiteSetting       long COLOR_OTHER_WHITE
                          
DAT

activeText              byte Pst#PC, MENU_DISPLAY_X, MODE_DISPLAY_Y
                        byte "Led Mode = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active Color = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active LEDs = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active Brightness = ", 13, 0
                       
modeMenuText            byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                          ' clear to bottom of screen
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte "Mode Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please select mode.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "O) Off (all LEDs off)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "L) Larson Scanner (cylon)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "S) Solid (all LEDs same color and brightness)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "D) Dragon Tail (muliple LEDs with diminishing brightness, "
                        byte "rotates through buffer)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "T) Dragon Tail (muliple LEDs with diminishing brightness, "
                        byte "bounces off buffer ends)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Rotating (buffer rotates)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "P) Pulse (buffer pulses)", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "B) Rainbow (fill buffer with repeating rainbow pattern)", 13, 0
                        byte Pst#PX, MENU_DISPLAY_X, "A) Cycling Pattern", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Y) Cycling Colors", 13
                        byte Pst#PX, MENU_DISPLAY_X, "X) Display Text", 13, 0
                        
modifyMenu              byte 13, Pst#PX, MENU_DISPLAY_X, "You may modify the current LEDs with following "
                        byte "commands", 13, 13, 0
modifyColor             byte Pst#PX, MENU_DISPLAY_X, "C) Color", 13, 0
modifyNumber            byte Pst#PX, MENU_DISPLAY_X, "N) Number (change the number of LEDs used in effect)", 13, 0
modifyBrightness        byte Pst#PX, MENU_DISPLAY_X, "Use ", 34, "+", 34, " or ", 34, "-", 34, "to change the "
                        byte "brightess", 13, 0
                        'byte Pst#PC, MENU_DISPLAY_X, BRIGHTNESS_DISPLAY_Y
                        'byte "brightness = ", 0
                        
colorMenuText           byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Color Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please select a color.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Red", 13
                        byte Pst#PX, MENU_DISPLAY_X, "O) Orange", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Y) Yellow", 13
                        byte Pst#PX, MENU_DISPLAY_X, "G) Green", 13
                        byte Pst#PX, MENU_DISPLAY_X, "B) Blue", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "I) Indigo (sort of)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "V) Violet (really purple)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "W) White", 13, 0
                        
{brightnessMenuText      byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte "Brightness Menu", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Press ", 34, "+", 34
                        byte " to increase brightness", 13
                        byte "Press ", 34, "-", 34, " to decrease brightness"
                        byte Pst#PC, MENU_DISPLAY_X, BRIGHTNESS_DISPLAY_Y
                        byte "brightness = ", 0      }

numberMenuText          byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte "Enter a Number", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please enter a number between ", 0

DAT
scrollingBuffer
freeDesign032           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign033           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
              
freeDesign034           byte %10100000
                        byte %10100000
                        byte %10100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                         
freeDesign035           byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign036           byte %01000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %01000000
              
freeDesign037           byte %01111100
                        byte %10100100
                        byte %10100100
                        byte %01001000
                        byte %00010010
                        byte %00100101
                        byte %00100101
                        byte %00100010
              
freeDesign038           byte %00111100
                        byte %01100100
                        byte %01100000
                        byte %00110000
                        byte %01000110
                        byte %11001100
                        byte %11001100
                        byte %01110110
              
freeDesign039           byte %10000000
                        byte %10000000
                        byte %10000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign040           byte %00100000
                        byte %01000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %01000000
                        byte %00100000

freeDesign041           byte %10000000
                        byte %01000000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01000000
                        byte %10000000
                         
freeDesign042           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %10101000
                        byte %01110000
                        byte %10101000
                        byte %00100000
                        byte %00000000

freeDesign043           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %00100000
                        byte %11111000
                        byte %00100000
                        byte %00100000
                        byte %00000000

freeDesign044           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
              
freeDesign045           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign046           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
              
freeDesign047           byte %00010000
                        byte %00010000
                        byte %00100000
                        byte %00100000
                        byte %01000000
                        byte %01000000
                        byte %10000000
                        byte %10000000
              
freeDesign048           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11101100
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign049           byte %01100000
                        byte %11100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
              
freeDesign050           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign051           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %01110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign052           byte %00011000
                        byte %00011000
                        byte %01011000
                        byte %01011000
                        byte %10011000
                        byte %11111100
                        byte %00011000
                        byte %00011000
              
freeDesign053           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign054           byte %00111000
                        byte %01000000
                        byte %11000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign055           byte %11111100
                        byte %00001100
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
              
freeDesign056           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign057           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00011000
                        byte %01110000
              
freeDesign058           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign059           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
                         
freeDesign060           byte %00000000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
              
freeDesign061           byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign062           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %00000000
              
freeDesign063           byte %11111000
                        byte %11001100
                        byte %00001100
                        byte %00011000
                        byte %00110000
                        byte %00100000
                        byte %00000000
                        byte %00110000
              
freeDesign064           byte %00111110
                        byte %01000001
                        byte %10011101
                        byte %10100101
                        byte %10100101
                        byte %10111111
                        byte %01000000
                        byte %00111110
              
freeDesign065           byte %00110000
                        byte %00110000
                        byte %00111000
                        byte %01011000
                        byte %01011000
                        byte %11111100
                        byte %10001100
                        byte %10001100
              
freeDesign066           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign067           byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
              
freeDesign068           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign069           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign070           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign071           byte %01111100
                        byte %11000100
                        byte %11000000
                        byte %11000000
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01110100
                         
freeDesign072           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign073           byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign074           byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %10011000
                        byte %01110000
              
freeDesign075           byte %11000100
                        byte %11001000
                        byte %11010000
                        byte %11110000
                        byte %11011000
                        byte %11011000
                        byte %11001100
                        byte %11001100
              
freeDesign076           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign077           byte %11000110
                        byte %11000110
                        byte %11101110
                        byte %11101110
                        byte %10110110
                        byte %10110110
                        byte %10000110
                        byte %10000110
              
freeDesign078           byte %11001000 
                        byte %11001000
                        byte %11101000
                        byte %11101000
                        byte %10111000
                        byte %10111000
                        byte %10011000
                        byte %10011000
              
freeDesign079           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign080           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                         
freeDesign081           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00001110
                         
freeDesign082           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign083           byte %01111000
                        byte %11001000
                        byte %11100000
                        byte %01110000
                        byte %00111000
                        byte %00011000
                        byte %10011000
                        byte %11110000
              
freeDesign084           byte %11111100
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign085           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign086           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign087           byte %11000001
                        byte %11000001
                        byte %01101001
                        byte %01101101
                        byte %01101101
                        byte %00110011
                        byte %00110011
                        byte %00110011
              
freeDesign088           byte %11001000
                        byte %11001000
                        byte %01110000
                        byte %01100000
                        byte %00110000
                        byte %01110000
                        byte %10011000
                        byte %10011000
              
freeDesign089           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign090           byte %11111000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign091           byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11110000

freeDesign092           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00000000

freeDesign093           byte %11110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %11110000
                         
freeDesign094           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %01010000
                        byte %10001000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign095           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11111111
                         
freeDesign096           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign097           byte %00000000
                        byte %01111000
                        byte %00001100
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00000000
                         
freeDesign098           byte %11000000
                        byte %11000000
                        byte %11111000
                        byte %11001100 
                        byte %11001100 
                        byte %11001100
                        byte %11111000
                        byte %00000000

freeDesign099           byte %00000000
                        byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
                        byte %00000000

freeDesign100           byte %00001100
                        byte %00001100
                        byte %01111100
                        byte %11001100 
                        byte %11001100 
                        byte %11001100 
                        byte %01111100
                        byte %00000000

freeDesign101           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11011000
                        byte %11100000
                        byte %11000100
                        byte %01111000
                        byte %00000000
              
freeDesign102           byte %00111000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %00000000
                         
freeDesign103           byte %00000000
                        byte %11111110
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %01111000
                         
freeDesign104           byte %11000000
                        byte %11000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign105           byte %00000000
                        byte %11000000 
                        byte %00000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign106           byte %00000000
                        byte %01100000 
                        byte %00000000
                        byte %01100000 
                        byte %01100000 
                        byte %01100000
                        byte %01100000
                        byte %11000000

freeDesign107           byte %11000000 
                        byte %11000100 
                        byte %11001000 
                        byte %11010000 
                        byte %11110000 
                        byte %11011000 
                        byte %11001100
                        byte %00000000

freeDesign108           byte %11000000 
                        byte %11000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign109           byte %00000000
                        byte %11010010
                        byte %11111111
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %00000000

freeDesign110           byte %00000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign111           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000

freeDesign112           byte %00000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                         
freeDesign113           byte %00000000
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00001100
              
freeDesign114           byte %00000000
                        byte %11010000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign115           byte %00000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %00000000

freeDesign116           byte %01100000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %00000000
              
freeDesign117           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000
                         
freeDesign118           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00000000

freeDesign119           byte %00000000
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %01101100
                        byte %01101100
                        byte %00000000
              
freeDesign120           byte %00000000
                        byte %11001100
                        byte %11101000
                        byte %01110000
                        byte %00111000
                        byte %01011100
                        byte %11001100
                        byte %00000000

freeDesign121           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00010000
                        byte %01110000
              
freeDesign122           byte %00000000
                        byte %11110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11110000
                        byte %00000000
              
freeDesign123           byte %00111000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00111000
                         
freeDesign124           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign125           byte %11100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %11100000
              
freeDesign126           byte %00000000
                        byte %00000000
                        byte %01110000
                        byte %10011001
                        byte %00001110
                        byte %00000000
                        byte %00000000
                        byte %00000000
DAT

testBuffer0             long 0[Led#BUFFER_SIZE]
{horizontal rainbow}    

testBuffer1             long COLOR_GREEN, COLOR_GREEN, COLOR_YELLOW, COLOR_YELLOW
{diagonal rainbow}      long COLOR_ORANGE, COLOR_ORANGE, COLOR_RED, COLOR_RED
                        
                        long COLOR_BLUE, COLOR_GREEN, COLOR_GREEN, COLOR_YELLOW
                        long COLOR_YELLOW, COLOR_ORANGE, COLOR_ORANGE, COLOR_RED
                        
                        long COLOR_BLUE, COLOR_BLUE, COLOR_GREEN, COLOR_GREEN
                        long COLOR_YELLOW, COLOR_YELLOW, COLOR_ORANGE, COLOR_ORANGE
                        
                        long COLOR_INDIGO, COLOR_BLUE, COLOR_BLUE, COLOR_GREEN
                        long COLOR_GREEN, COLOR_YELLOW, COLOR_YELLOW, COLOR_ORANGE
                        
                        long COLOR_INDIGO, COLOR_INDIGO, COLOR_BLUE, COLOR_BLUE
                        long COLOR_GREEN, COLOR_GREEN, COLOR_YELLOW, COLOR_YELLOW
                        
                        long COLOR_VIOLET, COLOR_INDIGO, COLOR_INDIGO, COLOR_BLUE
                        long COLOR_BLUE, COLOR_GREEN, COLOR_GREEN, COLOR_YELLOW
                        
                        long COLOR_VIOLET, COLOR_VIOLET, COLOR_INDIGO, COLOR_INDIGO
                        long COLOR_BLUE, COLOR_BLUE, COLOR_GREEN, COLOR_GREEN
                        
                        long COLOR_RED, COLOR_VIOLET, COLOR_VIOLET, COLOR_INDIGO
                        long COLOR_INDIGO, COLOR_BLUE, COLOR_BLUE, COLOR_GREEN

DAT fontSpace           long 0[FONT_LONGS_IN_EEPROM]
scratchSpace            long 0[FONT_LONGS_IN_EEPROM] ' some empty bytes for between character space

testBuffer2             long COLOR_GREEN, COLOR_GREEN
                        long COLOR_YELLOW, COLOR_YELLOW
{diagonal rainbow}      long COLOR_ORANGE, COLOR_ORANGE
                        long COLOR_RED, COLOR_RED
                        
                        long COLOR_BLUE, COLOR_GREEN
                        long COLOR_GREEN, COLOR_YELLOW
                        long COLOR_YELLOW, COLOR_ORANGE
                        long COLOR_ORANGE, COLOR_RED
                        
                        long COLOR_BLUE, COLOR_BLUE
                        long COLOR_GREEN, COLOR_GREEN
                        long COLOR_YELLOW, COLOR_YELLOW
                        long COLOR_ORANGE, COLOR_ORANGE
                        
                        long COLOR_INDIGO, COLOR_BLUE
                        long COLOR_BLUE, COLOR_GREEN
                        long COLOR_GREEN, COLOR_YELLOW
                        long COLOR_YELLOW, COLOR_ORANGE
                        
                        long COLOR_INDIGO, COLOR_INDIGO
                        long COLOR_BLUE, COLOR_BLUE
                        long COLOR_GREEN, COLOR_GREEN
                        long COLOR_YELLOW, COLOR_YELLOW
                        
                        long COLOR_VIOLET, COLOR_INDIGO
                        long COLOR_INDIGO, COLOR_BLUE
                        long COLOR_BLUE, COLOR_GREEN
                        long COLOR_GREEN, COLOR_YELLOW
                        
                        long COLOR_VIOLET, COLOR_VIOLET
                        long COLOR_INDIGO, COLOR_INDIGO
                        long COLOR_BLUE, COLOR_BLUE
                        long COLOR_GREEN, COLOR_GREEN
                        
                        long COLOR_RED, COLOR_VIOLET
                        long COLOR_VIOLET, COLOR_INDIGO
                        long COLOR_INDIGO, COLOR_BLUE
                        long COLOR_BLUE, COLOR_GREEN

                        
DAT patternD00          long 0[Led#BUFFER_SIZE]

patternD01              long 0[Led#BUFFER_SIZE]
patternD02              long 0[Led#BUFFER_SIZE]
                             '         1         2         3         4         5         6
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer       byte "Parallax Propeller driving G-35 RGB Christmas lights. LEDs are fun!   ",0[LARGEST_TEXT_MESSAGE - 61]
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer0      byte "Merry Christmas!!  ",0
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer1      byte "Happy Birthday Eric Ostendorff!   ",0
                             '1234567890123456789012345678901234567890123456789012345678901     
'DAT messageBuffer       byte "Parallax Propeller driving 8X8 RGB LED array. LEDs are fun!   ",0[LARGEST_TEXT_MESSAGE - 61]
DAT end                 byte $AA[$100]                                                    